#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
 
using namespace std;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef long double ld;
 
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pdd;
 
#define ff(i,a,b) for(int i = a; i <= b; i++)
#define fb(i,b,a) for(int i = b; i >= a; i--)
#define trav(a,x) for (auto& a : x)
 
#define sz(a) (int)(a).size()
#define pb push_back
#define fi first
#define se second
#define lb lower_bound
#define ub upper_bound
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
 
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

const int mod = 1000000007;
const ll inf = 1e18 + 5;
const int mxN = 200005; 

int n, q;
int T[mxN];
ll K[mxN];

ll pref[mxN];
ll zbir[mxN];

ll sum(int l, int r, ll X){
    if(l > r)return 0;
    return zbir[r] - zbir[l - 1] - 1ll * (r - l + 1) * (pref[l - 1] - X);
}

int lift[mxN][20];
ll kol[mxN][20];

ll sp1[mxN][20];
ll rmq1(int l, int r){
    int x = 31 - __builtin_clz(r - l + 1);
    return min(sp1[l][x], sp1[r - (1 << x) + 1][x]);
}

ll sp2[mxN][20];
ll rmq2(int l, int r){
    int x = 31 - __builtin_clz(r - l + 1);
    return max(sp2[l][x], sp2[r - (1 << x) + 1][x]);
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    cin >> n;
    ff(i,1,n)cin >> T[i];
    ff(i,1,n)cin >> K[i];

    ff(i,1,n)pref[i] = pref[i - 1] + (T[i] == 3 ? K[i] : 0ll);
    
    ff(i,1,n)zbir[i] = zbir[i - 1] + pref[i];

    ff(i,1,n){
        sp1[i][0] = (T[i] == 1 ? K[i] - pref[i] : inf);
        sp2[i][0] = (T[i] == 2 ? K[i] - pref[i] : -inf);
    }
    for(int j = 1; j < 20; j++){
        for(int i = 1; i + (1 << j) - 1 <= n; i++){
            sp1[i][j] = min(sp1[i][j - 1], sp1[i + (1 << (j - 1))][j - 1]);
            sp2[i][j] = max(sp2[i][j - 1], sp2[i + (1 << (j - 1))][j - 1]);
        }
    }

    fb(i,n,1){
        if(T[i] == 3)continue;

        int P_one = 0;
        {
            int l = i, r = n, ans = n + 1;
            while(l <= r){
                int mid = (l + r) / 2;
                if(rmq1(i, mid) < K[i] - pref[i - 1]){
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }

            P_one = ans;
        }

        int P_two = 0;
        {
            int l = i, r = n, ans = n + 1;
            while(l <= r){
                int mid = (l + r) / 2;
                if(rmq2(i, mid) > K[i] - pref[i - 1]){
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }

            P_two = ans;
        }

        int P = min(P_one, P_two);

        lift[i][0] = P;
        kol[i][0] = sum(i, P - 1, K[i]);

    }

    fb(i,n,1){
        ff(j,1,19){
            lift[i][j] = lift[lift[i][j - 1]][j - 1];
            kol[i][j] = kol[i][j - 1] + kol[lift[i][j - 1]][j - 1];
        }
    }

    cin >> q;
    while(q--){
        int L, R; ll X;
        cin >> L >> R >> X; 

        int P_one = 0;
        {
            int l = L, r = R, ans = R + 1;
            while(l <= r){
                int mid = (l + r) / 2;
                if(rmq1(L, mid) < X - pref[L - 1]){
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }

            P_one = ans;
        }

        int P_two = 0;
        {
            int l = L, r = R, ans = R + 1;
            while(l <= r){
                int mid = (l + r) / 2;
                if(rmq2(L, mid) > X - pref[L - 1]){
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }

            P_two = ans;
        }

        int P = min(P_one, P_two);

        ll rez = sum(L, P - 1, X);

        fb(i,19,0){
            if(lift[P][i] != 0 && lift[P][i] <= R){
                rez += kol[P][i];
                P = lift[P][i];
            }
        }

        rez += sum(P, R, K[P]);

        cout << rez << '\n';

    }

    return 0;
}
/*

9
2 2 1 2 1 3 3 1 3 
75 78 -68 19 -63 -69 -34 -78 -18 
1
1 6 -40
 
5
3 3 2 1 3
3 8 -7 -6 -6
1
1 1 4
 
// probati bojenje sahovski
*/